from math import sin, cos, pi
from random import gauss # More natural than the regular random
#stalk_length = 70
#edge_length = 30
#var("BRANCH_ANGLE", NUMBER, pi*0.2, 0.0, pi/2)
#BRANCH_ANGLE = pi*0.2
size(600, 600)
transform(CORNER)
rotate(180)
translate(-(WIDTH/2), -HEIGHT)
scale(-1, 1)
class Edge:
    def __init__(self, start_point, length, angle):
        self.start_point = start_point
        self.length = length
        self.angle = angle
    def translate(self, trans_point):
        self.start_point.x += trans_point.x
        self.start_point.y += trans_point.y
        return self.start_point
    def rotate(self, rot_angle):
        self.angle += rot_angle
        return self.angle
    def get_endpoint(self):
        end_point = Point()
        end_point.x = self.start_point.x+self.length*cos(self.angle)
        end_point.y = self.start_point.y+self.length*sin(self.angle)
        return end_point
    def draw(self):
        end_point = self.get_endpoint()
        line(self.start_point.x, self.start_point.y, end_point.x, end_point.y)
    def line_to_start(self): lineto(self.start_point.x, self.start_point.y)
    def line_to_end(self):
        end_point = self.get_endpoint()
        lineto(end_point.x, end_point.y)

class Generator:
    def __init__(self, start_edge, generation, fertile_edge_length, edge_length, stalk_length):
        BRANCH_ANGLE = gauss(pi*0.2, 0.1)
        self.generator_edge = [None]*8
        self.generator_edge[0] = Edge(
                                      start_edge.start_point,
                                      stalk_length,
                                      (pi/2)+start_edge.angle)
        self.generator_edge[1] = Edge(
                                      self.generator_edge[0].get_endpoint(),
                                      edge_length,
                                      self.generator_edge[0].angle+BRANCH_ANGLE)
        self.generator_edge[2] = Edge(
                                      self.generator_edge[1].get_endpoint(),
                                      fertile_edge_length,
                                      self.generator_edge[1].angle-(pi/2))
        self.generator_edge[3] = Edge(
                                      self.generator_edge[2].get_endpoint(),
                                      edge_length*cos(BRANCH_ANGLE),
                                      self.generator_edge[2].angle+(3*pi/2))
        self.generator_edge[7] = Edge(
                                      start_edge.get_endpoint(),
                                      stalk_length,
                                      start_edge.angle+(pi/2))
        self.generator_edge[6] = Edge(
                                      self.generator_edge[7].get_endpoint(),
                                      edge_length,
                                      self.generator_edge[7].angle-BRANCH_ANGLE)
        temp_edge =              Edge(
                                      self.generator_edge[6].get_endpoint(),
                                      fertile_edge_length,
                                      self.generator_edge[6].angle+(pi/2))
        self.generator_edge[5] = Edge(
                                      temp_edge.get_endpoint(),
                                      fertile_edge_length,
                                      self.generator_edge[6].angle-(pi/2))
        self.generator_edge[4] = Edge(
                                      self.generator_edge[5].start_point,
                                      edge_length*cos(BRANCH_ANGLE),
                                      self.generator_edge[5].angle-(pi/2))
    def draw(self):
        beginpath(self.generator_edge[0].start_point.x, self.generator_edge[0].start_point.y)
        for edge in self.generator_edge[1:6]:
            edge.line_to_start()
            edge.line_to_end()
        for edge in self.generator_edge[7:]:
            edge.line_to_end()
            edge.line_to_start()
        endpath()

fertile_edges = []
new_fertile_edges = []
fertile_edge_length = 30
edge_length = 30
stalk_length = 70
growth_factor = 0.8
fertile_edges += [Edge(Point(-15, 0), fertile_edge_length, 0)]
generations = 10
colormode(HSB)
background(0)
stroke(0)
for i in range(generations):
    fertile_edge_length *= growth_factor
    edge_length *= growth_factor
    stalk_length *= growth_factor
    for edge in fertile_edges:
        new_growth = Generator(edge, i, fertile_edge_length, edge_length, stalk_length)
        fill(float(i)/float(generations), 1, 1, 1.5-(float(i)/float(generations)))
        new_growth.draw()
        new_fertile_edges += [new_growth.generator_edge[2]]
        new_fertile_edges += [new_growth.generator_edge[5]]
    fertile_edges = new_fertile_edges
    new_fertile_edges = []
#draw initiator (stores an edge in fertile_edges)
#repeat for x interations
#    for each edge in fertile_edges
#        draw generator on that edge (stores an edge in new_fertile_edges)
#    end
#    replace fertile_edges with new_fertile_edges
#end

#for edge in root.generator_edge[:8]: edge.draw()
#stroke(1, 0, 0)
#oval(initial_edge.start_point.x-5, initial_edge.start_point.y-5, 10, 10)
#root.draw()